#!/usr/bin/env python
# -*- Python -*-
#
# Sample script for using optracker
#
try:
    import optracker
except ImportError:
    raise ImportError,"Python interpter not compiled for opcode tracking"
    
import opstats,sys
optr = optracker.CreateTracker()

print "starting profiling..."
# start tracking opcode execution
optracker.StartTracking(optr)

## Generate some data
# run a program, e.g., Python-1.4/Tools/scripts/pystone.py
# REPLACE THIS with your application: 
import profile
profile.run('import pystone; pystone.LOOPS=100;pystone.main()')

# stop opcode tracking
optracker.StopTracking()

## Do some analysis 

# print out the results...
reload(opstats)
o = opstats.OpCodeStats(optr)
p = opstats.OStats(o)

# now p is a normal pstat Stats object.
# See profile.doc in the standard distribution for more usage.
# print out the 20 opcodes which took the longest to execute
p.sort_stats('time').print_stats(20)

# OStats object has a method to return the matrix of transition probabilities
transition_probability_lists = o.calculate_prev_prob()

# if you have the excellent NumPy numeric package:
try:
    from Numeric import *
except ImportError:
    print "no NumPy installed, skipping...."
    sys.exit()

print "Using NumPy for further analysis.."    
trans = array(transition_probability_lists)
# find which opcodes were followed by the same opcode more than
# 75% of the time:
gr75 = nonzero(ravel(greater(trans,0.75)))

# print out a list of the transition probabilities 
offset_to_index = (lambda x,l=optracker.opcode_listsize: (x/l, x % l))
for cur_op,prev_op in map(offset_to_index,gr75):
    cname,pname  = optracker.opcode_dict[cur_op],optracker.opcode_dict[prev_op]
    print '%15s is followed by %15s %.3g%%' % (cname,pname,100*trans[cur_op,prev_op])




